<?php
function xoops_module_update_amaxoop2(&$module, $prev_version) {
	global $xoopsDB, $msgs;

	if(defined('XOOPS_CUBE_LEGACY')) {
		$root =& XCube_Root::getSingleton();
		$root->mDelegateManager->add( 'Legacy.Admin.Event.ModuleUpdate.Amaxoop2.Success', 'amaxoop2_append_update_info_xcube' ) ;
		$msgs = array() ;
	} else {
		if (!is_array($msgs)) {
			$msgs = array();
		}
	}
	$msgs[] = 'Executing  xoops_module_update_amaxoop2.';

	if ($prev_version < 91) {
		$msgs[] = '&nbsp;&nbsp;<b>Version 0.9 -&gt; 0.91</b>';
		$sql =	"ALTER TABLE ".$xoopsDB->prefix('amaxoop2_items')." ".
			"CHANGE Excerpt Excerpt varchar(255) NOT NULL default '', ".
			"DROP SmallImageURL, ".
			"CHANGE MediumImageURL MediumImageURL varchar(255) NOT NULL default '', ".
			"CHANGE Title Title varchar(255) NOT NULL default '', ".
			"CHANGE Availability Availability varchar(255) NOT NULL default '', ".
			"CHANGE ProductGroup ProductGroup varchar(16) NOT NULL default '', ".
			"CHANGE Creators Creators varchar(255) NOT NULL default '', ".
			"CHANGE Manufacturer Manufacturer varchar(255) NOT NULL default '', ".
			"CHANGE FormattedPrice FormattedPrice varchar(16) NOT NULL default '', ".
			"ADD ProductType varchar(64), ".
			"ADD PriceDown int(2) NOT NULL default 0";
		if ($xoopsDB->queryF($sql)) {
			$msgs[] = '1 table changed. ';
		}
		$sql =	"DROP TABLE ".$xoopsDB->prefix('amaxoop2_aws_cache').", ".$xoopsDB->prefix('amaxoop2_bnodes');
		if ($xoopsDB->queryF($sql)) {
			$msgs[] = '2 tables dropped.';
		}
	}

	if ($prev_version < 96) {
		$msgs[] = '&nbsp;&nbsp;<b>Version 0.95 -&gt; 0.96</b>';
		$sql =	"ALTER TABLE ".$xoopsDB->prefix('amaxoop2_items')." ".
			"ADD VoteAve int(5) unsigned NOT NULL default 0";
		if ($xoopsDB->queryF($sql)) {
			$msgs[] = '1 table changed. ';
		}
		$res = $xoopsDB->query("SELECT lid, SUM(Rating), COUNT(id) FROM ".$xoopsDB->prefix('amaxoop2_votedata')." GROUP BY lid");
		$cnt = 0;
		while (list($lid, $VoteSum, $Votes) = $xoopsDB->fetchRow($res)) {
			$VoteAve = ceil(100 * $VoteSum / $Votes);
			$xoopsDB->queryF("UPDATE ".$xoopsDB->prefix('amaxoop2_items')." SET VoteAve = $VoteAve WHERE lid = $lid");
			$cnt++;
		}
		$msgs[] = $cnt.' data field added.';
	}

	if ($prev_version < 100) {
		$msgs[] = '&nbsp;&nbsp;<b>Version 0.99 -&gt; 1.00</b>';
		$sql =	"ALTER TABLE ".$xoopsDB->prefix('amaxoop2_items')." ADD cid2 int(5) unsigned NOT NULL default 0";
		if ($xoopsDB->queryF($sql)) {
			$msgs[] = '1 table changed. ';
		}
		$sql =	"CREATE TABLE ".$xoopsDB->prefix('amaxoop2_subcategories')." (".
			"cid2 int(5) unsigned NOT NULL auto_increment, ".
			"cid int(5) NOT NULL default 0, ".
			"COrder2 int(5) unsigned NOT NULL default 1, ".
			"CTitle2 varchar(255) NOT NULL default '', ".
			"BuiltTime2 int(10) unsigned NOT NULL default 0, ".
			"PRIMARY KEY (cid2)) TYPE=MyISAM";
		if ($xoopsDB->queryF($sql)) {
			$msgs[] = '1 table added. ';
		}
	}

	if ($prev_version < 102) {
		$sql =	"UPDATE ".$xoopsDB->prefix('amaxoop2_items')." SET MediumImageURL = ''".
			" WHERE (MediumImageURL LIKE 'javascript:%') OR (MediumImageURL LIKE 'vbscript:%')".
			" OR (MediumImageURL LIKE 'about:%')";
		$xoopsDB->queryF($sql);
	}

	if ($prev_version < 109) {
		$msgs[] = '&nbsp;&nbsp;<b>Version 1.08 -&gt; 1.09</b>';
		$sql =	"ALTER TABLE ".$xoopsDB->prefix('amaxoop2_items')." ADD Keywords varchar(255) NOT NULL default '', ".
			"ADD SearchIdx varchar(255) NOT NULL default ''";
		if ($xoopsDB->queryF($sql)) {
			$msgs[] = '1 table changed.';
		}
	}

	if ($prev_version < 110) {
		$msgs[] = '&nbsp;&nbsp;<b>Version 1.09 -&gt; 1.10</b>';
		$sql =	"ALTER TABLE ".$xoopsDB->prefix('amaxoop2_asins')." ADD Impression int(11) unsigned NOT NULL default 1, ".
			"ADD Title varchar(64) default ''";
		if ($xoopsDB->queryF($sql)) {
			$msgs[] = '1 table changed.';
		}
		$sql = "UPDATE ".$xoopsDB->prefix('amaxoop2_asins')." SET Impression = Clicks";
		$xoopsDB->queryF($sql);
	}

	if ($prev_version < 112) {
		$msgs[] = '&nbsp;&nbsp;<b>Version 1.11 -&gt; 1.12</b>';
		$sql =	"ALTER TABLE ".$xoopsDB->prefix('amaxoop2_items')." CHANGE VotesAve VoteAve int(5) unsigned NOT NULL default 0";
		if ($xoopsDB->queryF($sql)) {
			$msgs[] = '1 table changed. ';
		}
		$sql =	"UPDATE ".$xoopsDB->prefix('amaxoop2_items')." SET VoteAve = 0";
		$xoopsDB->queryF($sql);
		$res = $xoopsDB->query("SELECT lid, SUM(Rating), COUNT(id) FROM ".$xoopsDB->prefix('amaxoop2_votedata')." GROUP BY lid");
		$cnt = 0;
		while (list($lid, $VoteSum, $Votes) = $xoopsDB->fetchRow($res)) {
			$VoteAve = ceil(100 * $VoteSum / $Votes);
			$xoopsDB->queryF("UPDATE ".$xoopsDB->prefix('amaxoop2_items')." SET VoteAve = $VoteAve WHERE lid = $lid");
			$cnt++;
		}
		$msgs[] = $cnt.' data field added. ';
	}

	include_once XOOPS_ROOT_PATH.'/modules/amaxoop2/templates/check_encoding.php';
//	$msgs[] = 'Template files are encoded as '._MI_AMAXOOP2_TMPL_ENCODING;
	$msgs[] = _MI_AMAXOOP2_TMPL_ENCODING_MSG;

	return true;
}

function amaxoop2_append_update_info_xcube (&$module_obj, &$log ) {
	if (is_array( @$GLOBALS['msgs'])) {
		foreach ($GLOBALS['msgs'] as $message) {
			$log->add(strip_tags($message)) ;
		}
	}
	// use mLog->addWarning() or mLog->addError() if necessary
}
?>