<?php
//  ------------------------------------------------------------------------ //
//              Amaxoop2 - Amazon Associate Module for XOOPS                 //
//                     Copyright (c) 2005 taquino                            //
//                     <http://xoops.taquino.net/>                           //
//                  This software is a 'traffic-ware'                        //
//  ------------------------------------------------------------------------ //

if (!defined('XOOPS_ROOT_PATH')) { exit(); }

require_once (XOOPS_ROOT_PATH.'/modules/amaxoop2/include/library.php');

//	$options : Number of Items, Sort Order
function amaxoop2_show_catitems($options) {
	global $xoopsDB;
	$Amaxoop2ModuleConfig = amaxoop2_getModulesConfig('amaxoop2');
	$myts =& MyTextSanitizer::getInstance();
	$cid = intval($options[0]);
	if ($cid == 0) { return ''; }
	$limit = ((intval($options[1]) > 0) ? intval($options[1]) : 5);
	if ($limit == 0) { return ''; }
	$SubCTitles = array();
	$sql = "SELECT cid2, CTitle2 FROM ".$xoopsDB->prefix('amaxoop2_subcategories')." WHERE cid = $cid";
	$res = $xoopsDB->query($sql);
	while (list($CI, $CT) = $xoopsDB->fetchRow($res)) {
		$SubCTitles[$CI] = $myts->htmlSpecialChars($CT);
	}
	if (!isset($options[2])) { $options[2] = ''; } else { $options[2] = addslashes($options[2]); }
	$order = (($options[2] != '') ? " ORDER BY ".$options[2] : " ORDER BY EntryTime DESC");
	$sql = "SELECT * FROM ".$xoopsDB->prefix('amaxoop2_items')." WHERE cid = $cid AND Status = 1 $order";
	$res = $xoopsDB->query($sql, $limit);
	$block = array();
	while ($dat = $xoopsDB->fetchArray($res)) {
		$item = array();
		foreach ($dat as $key => $val) {
			if (preg_match('/^(lid|cid|cid2|Clicks|IsItAdult)$/', $key)) { $item[$key] = intval($val); }
			elseif (preg_match('/^(Title|FormattedPrice|Manufacturer|Creators|uname|Excerpt)$/', $key))
				{ $item[$key] = $myts->htmlSpecialChars($val); }
			elseif (preg_match('/^(MediumImageURL|ASIN)$/', $key)) { $item[$key] = $val; }
			elseif (preg_match('/^EntryTime$/', $key)) { $item[$key] = strftime('%Y/%m/%d', $val); }
		}
		// if (preg_match('/^([^\[\(\<&]+)([\[\(\<&])/', $item['Title'], $m)) { $item['Title'] = $m[1].' ...'; }
		$item['CreatorsF'] = preg_replace('/(\([^\)]*\))/', '', $item['Creators']);
		$item['ManufacturerF'] = (($item['Manufacturer'] != '') ? '&nbsp;('.$item['Manufacturer'].')&nbsp;' : '');
		if (!isset($item['MediumImageURL']) || ($item['MediumImageURL'] == '')) {
			$item['MediumImageURL'] = _AMAX2_NoImageURL;
		}
		$item['ThumbnailURL'] = amaxoop2_ThumbnailURL($item['MediumImageURL'], _AMAX2_DefaultThumbSize);
		// $item['ShortTitle'] = preg_replace('/^(.+?)([\(|\[|<|&].*)$/', '\\1 ...', $item['Title']);
		$item['ShortTitle'] = amaxoop2_AutoExcerpt($item['Title'], _AMAX2_BlockTitleLength, _CHARSET);
		$item['LongTitle'] = "{$item['Title']}\n\n${item['CreatorsF']} ${item['ManufacturerF']}";
		if (isset($SubCTitles[$item['cid2']])) { $item['SubCTitle'] = $SubCTitles[$item['cid2']]; }
			else { $item['SubCTitle'] = ''; }
		$block['items'][] = $item;
	}
	$block['Amaxoop2ModConfig'] = $Amaxoop2ModuleConfig;
	return $block;
}

function amaxoop2_show_catitems_edit($options) {
	global $xoopsDB;
	$sql = "SELECT cid, CTitle, COrder FROM ".$xoopsDB->prefix('amaxoop2_categories')." ORDER BY COrder";
	$res = $xoopsDB->query($sql);
	$form = _MB_AMAXOOP2_CATEGORY.'<select name="options[]">';
	while ($cat = $xoopsDB->fetchArray($res)) {
		if ($cat['cid'] == $options[0]) { $selected = ' selected = "selected"'; } else { $selected = ''; }
		$form .= '<option value="'.$cat['cid'].'"'.$selected.'>'.htmlspecialchars($cat['CTitle']).'</option>';
	}
	$form .= '</select><br />';
	$form .= _MB_AMAXOOP2_ITEMS.'&nbsp;<input type="text" name="options[]" value="'.$options[1].'" size="3" /><br />';
	$sort = array('EntryTime DESC' => _MB_AMAXOOP2_SORT_NEW, 'Clicks DESC, EntryTime DESC' => _MB_AMAXOOP2_SORT_CLICKS,
	              'VoteAve DESC, Clicks DESC, EntryTime DESC' => _MB_AMAXOOP2_SORT_VOTES, 'RAND()' => _MB_AMAXOOP2_SORT_RAND);
	$form .= _MB_AMAXOOP2_SORT.'<select name="options[]">';
	foreach ($sort as $key => $val) {
		if ($key == $options[2]) { $selected = ' selected = "selected"'; } else { $selected = ''; }
		$form .= '<option value="'.$key.'"'.$selected.'>'.$val.'</option>';
	}
	$form .= '</select>';
	return $form;
}

?>