<?php
//  ------------------------------------------------------------------------ //
//              Amaxoop2 - Amazon Associate Module for XOOPS                 //
//                     Copyright (c) 2005 taquino                            //
//                     <http://xoops.taquino.net/>                           //
//                  This software is a 'traffic-ware'                        //
//  ------------------------------------------------------------------------ //

if (!defined('XOOPS_ROOT_PATH')) { exit(); }

require_once (XOOPS_ROOT_PATH.'/modules/amaxoop2/include/library.php');

//	$options : Number of Items, Sort Order
function amaxoop2_show_items($options) {
	global $xoopsDB;
	$Amaxoop2ModuleConfig = amaxoop2_getModulesConfig('amaxoop2');
	$myts =& MyTextSanitizer::getInstance();
	$CTitles = array();
	$res2 = $xoopsDB->query("SELECT cid, CTitle FROM ".$xoopsDB->prefix('amaxoop2_categories'));
	while (list($cid, $CTitle) = $xoopsDB->fetchRow($res2)) {
		$CTitles[$cid] = $myts->htmlSpecialChars($CTitle);
	}
	$limit = ((intval($options[0]) > 0) ? intval($options[0]) : 5);
	$order = (($options[1] != '') ? " ORDER BY ".$options[1] : " ORDER BY EntryTime DESC");
	$sql = "SELECT * FROM ".$xoopsDB->prefix('amaxoop2_items')." WHERE Status = 1 $order";
	$res = $xoopsDB->query($sql, $limit);
	$block = array();
	while ($dat = $xoopsDB->fetchArray($res)) {
		$item = array();
		foreach ($dat as $key => $val) {
			if (preg_match('/^(lid|cid|Clicks|IsItAdult)$/', $key)) { $item[$key] = intval($val); }
			elseif (preg_match('/^(Title|FormattedPrice|Manufacturer|Creators|uname|Excerpt)$/', $key))
				{ $item[$key] = $myts->htmlSpecialChars($val); }
			elseif (preg_match('/^(MediumImageURL|ASIN)$/', $key)) { $item[$key] = $val; }
			elseif (preg_match('/^(EntryTime)$/', $key)) { $item[$key] = strftime('%Y/%m/%d', $val); }
		}
		// if (preg_match('/^([^\[\(\<&]+)([\[\(\<&])/', $item['Title'], $m)) { $item['Title'] = $m[1].' ...'; }
		$item['CreatorsF'] = preg_replace('/(\([^\)]*\))/', '', $item['Creators']);
		$item['ManufacturerF'] = (($item['Manufacturer'] != '') ? '&nbsp;('.$item['Manufacturer'].')&nbsp;' : '');
		if (!isset($item['MediumImageURL']) || ($item['MediumImageURL'] == '')) {
			$item['MediumImageURL'] = _AMAX2_NoImageURL;
		}
		$item['ThumbnailURL'] = amaxoop2_ThumbnailURL($item['MediumImageURL'], _AMAX2_DefaultThumbSize);
		// $item['ShortTitle'] = preg_replace('/^(.+?)([\(|\[|<|&].*)$/', '\\1 ...', $item['Title']);
		$item['ShortTitle'] = amaxoop2_AutoExcerpt($item['Title'], _AMAX2_BlockTitleLength, _CHARSET);
		$item['LongTitle'] = "{$item['Title']}\n\n${item['CreatorsF']} ${item['ManufacturerF']}";
		$item['CTitle'] = $CTitles[$item['cid']];
		$block['items'][] = $item;
	}
	$block['Amaxoop2ModConfig'] = $Amaxoop2ModuleConfig;
	return $block;
}

function amaxoop2_show_items_edit($options) {
	$form  = _MB_AMAXOOP2_ITEMS.'&nbsp;<input type="text" name="options[]" value="'.$options[0].'" size="3" /><br />';
	$sort = array('EntryTime DESC' => _MB_AMAXOOP2_SORT_NEW, 'Clicks DESC, EntryTime DESC' => _MB_AMAXOOP2_SORT_CLICKS,
	              'VoteAve DESC, Clicks DESC, EntryTime DESC' => _MB_AMAXOOP2_SORT_VOTES, 'RAND()' => _MB_AMAXOOP2_SORT_RAND);
	$form .= _MB_AMAXOOP2_SORT.'<select name="options[]">';
	foreach ($sort as $key => $val) {
		if ($key == $options[1]) { $selected = ' selected = "selected"'; } else { $selected = ''; }
		$form .= '<option value="'.$key.'"'.$selected.'>'.$val.'</option>';
	}
	$form .= '</select>';
	return $form;
}

?>