<?php
if (!defined('XOOPS_ROOT_PATH')) { exit(); }

function amaxoop2_new($limit=0, $offset=0)
{
	global $xoopsDB;
	include XOOPS_ROOT_PATH.'/modules/amaxoop2/include/parameters.php';
	$module_handler =& xoops_gethandler('module');
	$module =& $module_handler->getByDirname('amaxoop2');
	$config_handler =& xoops_gethandler('config');
	$Amaxoop2ModConfig = $config_handler->getConfigsByCat(0, $module->getVar('mid'));
	$myts =& MyTextSanitizer::getInstance();

	$sql = "SELECT cid, CTitle FROM ".$xoopsDB->prefix('amaxoop2_categories');
	$res = $xoopsDB->query($sql);
	$catTitle = array();
	while (list($cid, $CTitle) = $xoopsDB->fetchRow($res)) {
		$catTitle[$cid] = $myts->displayTarea($CTitle, 0, 0, 0);
	}

	$sql = "SELECT * FROM ".$xoopsDB->prefix("amaxoop2_items")." WHERE Status = 1 ORDER BY EntryTime DESC";
	$res = $xoopsDB->query($sql, $limit, $offset);
	$i = 0;
	$ret = array();
 	while ($row = $xoopsDB->fetchArray($res))
 	{
 		$lid = $row['lid'];
		$cid = $row['cid'];

		$ret[$i]['id']		= $lid;
		if ($Amaxoop2ModConfig['BlogOrLink']) {
			$ret[$i]['link']	= XOOPS_URL."/modules/amaxoop2/article.php?lid=".$lid;
		} else {
			$ret[$i]['link']	= XOOPS_URL."/modules/amaxoop2/index.php?lid=${lid}#amaxoop2_item_${lid}";
		}
		$ret[$i]['cat_link']	= XOOPS_URL."/modules/amaxoop2/index.php?cid=".$cid;
		$ret[$i]['cat_name']	= $catTitle[$cid];

		$ret[$i]['title']	= $myts->htmlSpecialChars($row['Title']);
		$ret[$i]['time']	= $row['EntryTime'];
		$ret[$i]['modified']	= $row['Updated'];

		$ret[$i]['description']	= $myts->htmlSpecialChars($row['Excerpt']);
		$ret[$i]['hits']	= $row['Clicks'];
		$ret[$i]['replies']	= $row['Comments'];

		$ret[$i]['uid']		= $row['uid'];

		if (isset($row['MediumImageURL']) && ($row['MediumImageURL'] != '')) {
			if (preg_match('/^([^\s"]+)/', $row['MediumImageURL'], $m)) { $ret[$i]['image'] = $m[1]; }
			if (preg_match('/width[\s\=\"]*([\d]+)/i', $row['MediumImageURL'], $m)) { $ret[$i]['width'] = $m[1]; }
			if (preg_match('/height[\s\=\"]*([\d]+)/i', $row['MediumImageURL'], $m)) { $ret[$i]['height'] = $m[1]; }
		} else {
			$ProductGroup	= $row['ProductGroup'];
			if (!isset($amaxoop2ProductIcon[$ProductGroup])) {
				$ret[$i]['image']	= XOOPS_URL."/modules/amaxoop2/images/amaxoop2tiny.gif";
				$ret[$i]['width']	= 22;
				$ret[$i]['height']	= 22;
			} else {
				$MyIconImage		= $amaxoop2ProductIcon[$ProductGroup];
				if (preg_match('/^([^\s"]+)/', $MyIconImage, $m)) { $ret[$i]['image'] = $m[1]; }
				if (preg_match('/width[\s\=\"]*([\d]+)/i', $MyIconImage, $m)) { $ret[$i]['width'] = $m[1]; }
				if (preg_match('/height[\s\=\"]*([\d]+)/i', $MyIconImage, $m)) { $ret[$i]['height'] = $m[1]; }
			}
		}

		$i++;
	}
	return $ret;
}

function amaxoop2_num()
{
	global $xoopsDB;
	$res = $xoopsDB->query("SELECT COUNT(lid) FROM ".$xoopsDB->prefix("amaxoop2_items")." WHERE Status = 1");
	if ($xoopsDB->getRowsNum($res) == 0) {
		return 0;
	} else {
		list($num) = $xoopsDB->fetchRow($res);
		return $num;
	}
}

function amaxoop2_data($limit=0, $offset=0)
{
	global $xoopsDB;
	$module_handler =& xoops_gethandler('module');
	$module =& $module_handler->getByDirname('amaxoop2');
	$config_handler =& xoops_gethandler('config');
	$Amaxoop2ModConfig = $config_handler->getConfigsByCat(0, $module->getVar('mid'));
	$sql = "SELECT lid, Title, EntryTime FROM ".$xoopsDB->prefix("amaxoop2_items")." WHERE Status = 1 ORDER BY EntryTime DESC";
	$result = $xoopsDB->query($sql, $limit, $offset);
	$i = 0;
	$ret = array();
	while($myrow = $xoopsDB->fetchArray($result))
	{
		$lid = $myrow['lid'];
		$ret[$i]['id']		= $lid;
		if ($Amaxoop2ModConfig['BlogOrLink']) {
			$ret[$i]['link']	= XOOPS_URL."/modules/amaxoop2/article.php?lid=".$lid;
		} else {
			$ret[$i]['link']	= XOOPS_URL."/modules/amaxoop2/index.php?lid=${lid}#amaxoop2_item_${lid}";
		}
		$ret[$i]['title']	= $myrow['Title'];
		$ret[$i]['time']	= $myrow['EntryTime'];
		$i++;
	}
	return $ret;
}
?>