<?php
//  ------------------------------------------------------------------------ //
//              Amaxoop2 - Amazon Associate Module for XOOPS                 //
//                     Copyright (c) 2005 taquino                            //
//                     <http://xoops.taquino.net/>                           //
//                  This software is a 'traffic-ware'                        //
//  ------------------------------------------------------------------------ //
//                    !! DO NOT CHANGE THIS FILE !!                          //
//  ------------------------------------------------------------------------ //
//
//	$Item  = amaxoop2_SearchASIN	($ASIN)
//	$Item  = amaxoop2_SearchEAN	($EAN, $SearchIndex)
//	$Item  = amaxoop2_SearchUPC	($UPC, $SearchIndex)
//	$Items = amaxoop2_SearchKeyWord	($KeyWords, $SearchIndex = 'Blended', $Page)
//	$Items = amaxoop2_SearchSimilar	($ASIN)
//	$Items = amaxoop2_SearchNode	($BrowseNode, $SearchIndex, $Page)
//	$Items = amaxoop2_GetNodeInfo	($BrowseNode)

//	AmazonWebService Version
if (!defined('_AMAX2_Aws_Version')) { define('_AMAX2_Aws_Version', '2007-01-15'); }
//if (!defined('_AMAX2_Aws_Version')) { define('_AMAX2_Aws_Version', '2007-07-16'); }

//	Proxy
if (!defined('_AMAX2_ProxyServer'))	{ define('_AMAX2_ProxyServer',	''); }
if (!defined('_AMAX2_ProxyPort'))	{ define('_AMAX2_ProxyPort',	''); }

function amaxoop2_SearchASIN ($ASIN) {
	return amaxoop2_search_by_code($ASIN, 'ASIN');
}
function amaxoop2_SearchEAN ($EAN, $SearchIndex = 'Blended') {
	return amaxoop2_search_by_code($EAN, 'EAN', $SearchIndex);
}
function amaxoop2_SearchISBN ($ISBN, $SearchIndex = 'Blended') {
	return amaxoop2_search_by_code($ISBN, 'ISBN', $SearchIndex);
}
function amaxoop2_SearchUPC ($UPC, $SearchIndex = 'Blended') {
	return amaxoop2_search_by_code($UPC, 'UPC', $SearchIndex);
}
function amaxoop2_search_by_code ($ItemId, $IdType = 'ASIN', $SearchIndex = 'Blended') {
	global $amaxoop2SearchIndexes;
	if ($ItemId == '') { return amaxoop2_error_xml('Parameter Error', "No IdType specified."); }
	if (!preg_match('/^(ASIN|EAN|UPC|ISBN)$/', $IdType)) { $IdType = 'ASIN'; }
	if (!isset($amaxoop2SearchIndexes[$SearchIndex])) { $SearchIndex = 'Blended'; }
	$Queries = array('Operation' => 'ItemLookup', 'ResponseGroup' => 'Large', 'IdType' => $IdType, 'ItemId' => $ItemId);
	if ($IdType != 'ASIN') { $Queries['SearchIndex'] = $SearchIndex; }
	return amaxoop2_fetch_aws($Queries);
}
function amaxoop2_search_by_code2 ($ItemId, $SearchIndex = 'Blended') {
	global $amaxoop2SearchIndexes;
	if ($ItemId == '') { return amaxoop2_error_xml('Parameter Error', "No IdType specified."); }
	if (!isset($amaxoop2SearchIndexes[$SearchIndex])) { $SearchIndex = 'Blended'; }
	$Queries = array('Operation' => 'ItemLookup', 'ResponseGroup' => 'Large',
			 'ItemLookup.1.IdType' => 'ASIN', 'ItemLookup.2.IdType' => 'ISBN',
			 'ItemId' => $ItemId,
			 'SearchIndex' => $SearchIndex,);
	if ($SearchIndex != 'Blended') { $Queries['Sort'] = 'salesrank'; }
	return amaxoop2_fetch_aws($Queries);
}
function amaxoop2_SearchKeyWord ($KeyWord, $SearchIndex = 'Blended', $Page = 1) {
	global $amaxoop2SearchIndexes;
	$Page	= ((intval($Page) != 0) ? intval($Page) : 1);
	if (!isset($amaxoop2SearchIndexes[$SearchIndex])) { $SearchIndex = 'Blended'; }
	if (trim($KeyWord) == '') { return amaxoop2_error_xml('Parameter Error', "No Keywords."); }
	$KeyWordU = urlencode(mb_convert_encoding(trim($KeyWord), 'UTF-8', _CHARSET));
	$Queries = array('Operation' => 'ItemSearch', 'ResponseGroup' => 'Large',
			 'Keywords' => $KeyWordU, 'Condition' => 'New', 'SearchIndex' => $SearchIndex,
			 'ItemPage' => $Page);
	if ($SearchIndex != 'Blended') { $Queries['Sort'] = 'salesrank'; }
	return amaxoop2_fetch_aws($Queries);
}
function amaxoop2_SearchKeyWord2 ($KeyWord, $SearchIndex = 'Blended', $Page = 1) {
	global $amaxoop2SearchIndexes;
	$Page	= ((intval($Page) != 0) ? intval($Page) : 1);
	if (!isset($amaxoop2SearchIndexes[$SearchIndex])) { $SearchIndex = 'Blended'; }
	if (trim($KeyWord) == '') { return amaxoop2_error_xml('Parameter Error', "No Keywords."); }
	$KeyWordU = urlencode(mb_convert_encoding(trim($KeyWord), 'UTF-8', _CHARSET));
	$Queries = array('Operation' => 'ItemSearch', 'ResponseGroup' => 'Medium,Offers,Images,Reviews',
			 'Keywords' => $KeyWordU, 'Condition' => 'New', 'SearchIndex' => $SearchIndex,
			 'ItemSearch.1.ItemPage' => $Page, 'ItemSearch.2.ItemPage' => $Page + 1);
	if ($SearchIndex != 'Blended') { $Queries['Sort'] = 'salesrank'; }
	return amaxoop2_fetch_aws($Queries);
}
function amaxoop2_SearchSimilar ($ASIN = '') {
	if ($ASIN == '') { return amaxoop2_error_xml('Parameter Error', "No ASIN specified."); }
	$Queries = array('Operation' => 'SimilarityLookup', 'ResponseGroup' => 'Medium,Offers,Images,Reviews',
			 'IdType' => 'ASIN', 'ItemId' => $ASIN);
	return amaxoop2_fetch_aws($Queries);
}
function amaxoop2_SearchNode ($BrowseNode, $SearchIndex, $Page = 1) {
	$Page	= ((intval($Page) != 0) ? intval($Page) : 1);
	$Queries = array('Operation' => 'ItemSearch', 'ResponseGroup' => 'Medium,Offers,Images,Reviews',
			 'SearchIndex' => $SearchIndex, 'BrowseNode' => $BrowseNode,
			 'ItemSearch.1.ItemPage' => $Page, 'ItemSearch.2.ItemPage' => $Page + 1, 'Sort' => 'salesrank');
	return amaxoop2_fetch_aws($Queries);
}

function amaxoop2_error_xml ($Code, $Message) {
	$res =	"<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"yes\"?>\n".
		"<Errors><Error><Code>$Code</Code>".
		"<Message>$Message</Message></Error></Errors>";
	return (mb_convert_encoding($res, 'UTF-8', _CHARSET));
}

function amaxoop2_fetch_aws ($Queries) {
	global $xoopsModuleConfig, $xoopsDB, $amaxoop2SearchIndexes, $amaxoopModuleConfig;
	$AwsSV = 'webservices.amazon.co.jp';
	$AwsPt = '80';
	$AwsPT = '/onca/xml';
	$ProxyHost = _AMAX2_ProxyServer;
	$ProxyPort = _AMAX2_ProxyPort;
	$AwsAH = '';
	if (isset($xoopsModuleConfig['AssociateID'])) {
		$myModuleConfig = $xoopsModuleConfig;
	} elseif (isset($amaxoopModuleConfig['AssociateID'])) {
		$myModuleConfig = $amaxoopModuleConfig;
	} else {
		$myModuleConfig = amaxoop2_getModulesConfig('amaxoop2');
	}
	if (is_array($Queries)) {
		foreach ($Queries as $key => $val) {
			$AwsAH .= trim($key).'='.trim($val).'&';
			$ParamError = false;
			if (($key == 'ItemId') && !preg_match('/^[a-zA-Z0-9]+$/', $val)) { $ParamError = true; }
			if (($key == 'BrowseNode') && !preg_match('/^[a-zA-Z0-9]+$/', $val)) { $ParamError = true; }
//			if (($key == 'SearchIndex') && !isset($amaxoop2SearchIndexes[$val])) { $ParamError = true; }
			if ($ParamError) { return amaxoop2_error_xml('Parameter Error', htmlspecialchars("$key ($val)")); }
		}
	}
	$Operation = $Queries['Operation'];
	if ($Operation == '') { amaxoop2_error_xml('Amaxoop2 Internal Error', 'No Operation Command'); }
	if ($AwsAH == '') { amaxoop2_error_xml('Amaxoop2 Internal Error', 'No Parameters'); }
	if ($myModuleConfig['SubscriptionID'] == '') { $SubscriptionID = '0EKVYRPBK0HDA1DP3EG2'; }
		else { $SubscriptionID = $myModuleConfig['SubscriptionID']; }
	if ($myModuleConfig['AssociateID'] == '') { $AssociateID = 'amaxoop-1-22'; }
		else { $AssociateID = $myModuleConfig['AssociateID']; }
	$AwsRQ = "Service=AWSECommerceService&".
		 "SubscriptionId=".urlencode($SubscriptionID)."&".
		 "AssociateTag=".urlencode($AssociateID)."&".
		 "ContentType=text/xml&${AwsAH}Version="._AMAX2_Aws_Version;
	$MyCacheCount = 0;
	if (($Operation == 'ItemLookup') || ($Operation == 'SimilarityLookup')) {
		$MyCacheFile = XOOPS_CACHE_PATH.'/mod_amaxoop2_aws_'.md5($AwsRQ).'.xml';
	} else {
		$MyCacheFile = '';
	}
	$CacheFiles = glob(XOOPS_CACHE_PATH.'/mod_amaxoop2_aws_*.xml');
	if (is_array($CacheFiles) && (count($CacheFiles) > 0)) {
		foreach ($CacheFiles as $CacheFile) {
			clearstatcache();
			if(filemtime($CacheFile) < time() - $myModuleConfig['CacheTime']) {
				@unlink($CacheFile);
			}
			$MyCacheCount++;
		}
	}
	clearstatcache();
	if (($MyCacheFile != '') && file_exists($MyCacheFile)) {
		if(false !== $fp = fopen($MyCacheFile, 'r')) {
			$AwsXML = '';
			while (!feof($fp)) { $AwsXML .= fgets($fp, 4096); }
			fclose($fp);
			return $AwsXML;
		}
	}
	if ($ProxyHost != '') {
		$fp = @fsockopen($ProxyHost, $ProxyPort, $errno, $errstr, 5);
		$RequestURI = "http://$AwsSV:$AwsPt$AwsPT?$AwsRQ";
	} else {
		$fp = @fsockopen($AwsSV, $AwsPt, $errno, $errstr, 5);
		$RequestURI = "$AwsPT?$AwsRQ";
	}
	// echo "http://$AwsSV:$AwsPt$AwsPT?$AwsRQ"; exit;
	if (!$fp) {
		return amaxoop2_error_xml('Connecting Error', 'Failed to connect AWS.');
	}
	if (!defined('AMAXOOP2_AWS_ACCESS')) { define('AMAXOOP2_AWS_ACCESS', 1); }
	$AwsRH  = "GET $RequestURI HTTP/1.0\r\nUser-Agent: Amaxoop2/PHP".phpversion()."\r\nHost: $AwsSV\r\n\r\n";
	fputs($fp, $AwsRH);
	$AwsRES = '';
	while (!feof($fp)) { $AwsRES .= fgets($fp, 1024); }
	fclose($fp);
	$AwsRES = str_replace("\r\n", "\n", $AwsRES);
	$AwsRES = mb_convert_encoding($AwsRES, 'UTF-8', 'UTF-8');
	list($AwsHD, $AwsXML) = explode("\n\n", $AwsRES, 2);
	preg_match('/^([\S]+) ([\d]{3}) ([^\n]*)/', $AwsHD, $matches);
	if (($matches[2] != 200) && ($matches[3] != 'OK')) {
		return amaxoop2_error_xml('Amazon Server Response Error', $matches[3]);
	}
	if (preg_match('/<Result>([^<]*Error[^<]*)<\/Result>/', $AwsXML, $matches)) {
		return amaxoop2_error_xml('Amazon Server Error', $matches[1]);
	}
	if (($MyCacheFile != '') && ($MyCacheCount < 1000) &&($myModuleConfig['CacheTime'] > 0)) {
		if (false !== $fp = fopen($MyCacheFile, 'w')) {
			fwrite($fp, $AwsXML);
			fclose($fp);
		}
	}
	unset ($Queries, $AwsRES, $fp);
	// echo mb_convert_encoding(nl2br(htmlspecialchars($AwsXML)), 'SJIS', 'UTF-8'); exit;
	return $AwsXML;
}
?>