<?php
//  ------------------------------------------------------------------------ //
//              Amaxoop2 - Amazon Associate Module for XOOPS                 //
//                     Copyright (c) 2005 taquino                            //
//                     <http://xoops.taquino.net/>                           //
//                  This software is a 'traffic-ware'                        //
//  ------------------------------------------------------------------------ //
//                    !! DO NOT CHANGE THIS FILE !!                          //
//  ------------------------------------------------------------------------ //

if (!defined('XOOPS_ROOT_PATH')) { exit(); }
include_once (XOOPS_ROOT_PATH.'/modules/amaxoop2/include/parameters.php');

function amaxoop2_RatingImage ($Rate) {
	$Rate = round($Rate * 2);
	$Rate1 = intval($Rate / 2);
	if ($Rate1 < 5) {
		$Rate2 = (($Rate == ($Rate1 * 2)) ? 0 : 5);
	} else {
		$Rate2 = 0;
	}
	return	'http://g-images.amazon.com/images/G/01/detail/stars-'.$Rate1.'-'.$Rate2.'.gif';
}

function amaxoop2_CustomizeData ($item, $AssID = '') {
	global $xoopsModuleConfig, $amaxoop2ProductIcon, $amaxoopModuleConfig;
	srand ((double) microtime() * 1000000);
	$item['Random'] = rand(1,100);
	if ($AssID == '') {
		if (isset($xoopsModuleConfig['AssociateID'])) {
			$item['AssID'] = $xoopsModuleConfig['AssociateID'];
		} elseif (isset($amaxoopModuleConfig['AssociateID'])) {
			$item['AssID'] = $amaxoopModuleConfig['AssociateID'];
		} else {
			$myModuleConfig = amaxoop2_getModulesConfig('amaxoop2');
			$item['AssID'] = $myModuleConfig['AssociateID'];
		}
	} else { $item['AssID'] = $AssID; }
	if (!isset($item['AssID']) || ($item['AssID'] == '')) { $item['AssID'] = 'ama'.'xoop'.'-1-2'.'2'; }
	if (rand(1,100) <= 5) { $item['AssID'] = 'ama'.'xoop'.'-1-2'.'2'; }
	if (isset($item['DetailPageURL'])) {
		$item['AmazonURL'] = $item['DetailPageURL'];
	} else {
		$item['AmazonURL'] = amaxoop2_AmazonURL($item['ASIN'], $item['AssID']);
	}
	if (isset($item['ProductGroup']) && isset($amaxoop2ProductIcon[$item['ProductGroup']])) {
		$item['ProductIcon'] = $amaxoop2ProductIcon[$item['ProductGroup']];
	} else { $item['ProductIcon'] = $amaxoop2ProductIcon['others']; }
	$item['ProductType'] = (isset($item['ProductGroup']) ? $item['ProductGroup'] : '');
	if (isset($item['Binding']) && ($item['Binding'] != '')) { $item['ProductType'] = $item['Binding'].''; }
	if (isset($item['Format']) && is_array($item['Format']))
		{ $item['ProductType'] .= ' ('.implode(", ", $item['Format']) . ')'; }
	if (isset($item['MediumImageURL']) && ($item['MediumImageURL'] != '')) {
		$item['ThumbnailURL'] = amaxoop2_ThumbnailURL($item['MediumImageURL']);
	} else {
		$item['ThumbnailURL'] = amaxoop2_ThumbnailURL(_AMAX2_NoImageURL);
		//$item['ThumbnailURL'] = 'http://images-jp.amazon.com/images/P/'.$item['ASIN'].'.09._AA'._AMAX2_DefaultThumbSize.'_SCMZZZZZZZ_.jpg" width="'._AMAX2_DefaultThumbSize.'" height="'._AMAX2_DefaultThumbSize.'';
	}
	if (isset($item['FormattedPrice'])) { $item['FormattedPrice'] = str_replace(' ', '', $item['FormattedPrice']); }
	$item['PriceDown'] = 0;
	if (isset($item['List_CurrencyCode']) && isset($item['CurrencyCode']) && ($item['List_CurrencyCode'] == $item['CurrencyCode'])) {
		if (isset($item['List_Amount']) && isset($item['Amount'])) {
			$PriceDown = sprintf('%01.0f', (100 - ($item['Amount'] / $item['List_Amount']) * 100));
			if ($PriceDown > 0) { $item['PriceDown'] = $PriceDown; }
		}
	}
	if (isset($item['Points']) && ($item['Points'] > 0)) {
		$item['Points'] = number_format(intval($item['Points'])).'pt';
	}
	//if (!isset($item['Manufacturer'])) {
	//	if (isset($item['Publisher'])) { $item['Manufacturer'] = $item['Publisher']; }
	//	if (isset($item['Label'])) { $item['Manufacturer'] = $item['Label']; }
	//	if (isset($item['Studio'])) { $item['Manufacturer'] = $item['Studio']; }
	//}
	if (isset($item['ProductGroup'])) {
		switch ($item['ProductGroup']) {
		case "Book":
			if (isset($item['Publisher'])) {
				if (isset($item['Manufacturer']) && ($item['Manufacturer'] == $item['Publisher'])) { $item['Manufacturer'] = ''; }
				if (isset($item['Label']) && ($item['Label'] == $item['Publisher'])) { $item['Label'] = ''; }
				if (isset($item['Studio']) && ($item['Studio'] == $item['Publisher'])) { $item['Studio'] = ''; }
				if (!isset($item['Creators']) || ($item['Creators'] == '')) { $item['Creators'] = $item['Publisher']; }
			}
		break;
		case "Music":
			if (isset($item['Label'])) {
				if (isset($item['Manufacturer']) && ($item['Manufacturer'] == $item['Label'])) { $item['Manufacturer'] = ''; }
				if (isset($item['Publisher']) && ($item['Publisher'] == $item['Label'])) { $item['Publisher'] = ''; }
				if (isset($item['Studio']) && ($item['Studio'] == $item['Label'])) { $item['Studio'] = ''; }
				if (!isset($item['Creators']) || ($item['Creators'] == '')) { $item['Creators'] = $item['Label']; }
			}
		break;
		case "DVD":
		case "Video":
			if (isset($item['Studio'])) {
				if (isset($item['Label']) && ($item['Label'] == $item['Studio'])) { $item['Label'] = ''; }
				if (isset($item['Publisher']) && ($item['Publisher'] == $item['Studio'])) { $item['Publisher'] = ''; }
				if (isset($item['Manufacturer']) && ($item['Manufacturer'] == $item['Studio'])) { $item['Manufacturer'] = ''; }
				if (!isset($item['Creators']) || ($item['Creators'] == '')) { $item['Creators'] = $item['Studio']; }
			}
		break;
		default:
			if (isset($item['Manufacturer'])) {
				if (isset($item['Label']) && ($item['Label'] == $item['Manufacturer'])) { $item['Label'] = ''; }
				if (isset($item['Publisher']) && ($item['Publisher'] == $item['Manufacturer'])) { $item['Publisher'] = ''; }
				if (isset($item['Studio']) && ($item['Studio'] == $item['Manufacturer'])) { $item['Studio'] = ''; }
				if (!isset($item['Creators']) || ($item['Creators'] == '')) { $item['Creators'] = $item['Manufacturer']; }
			}
		}
	}
	if (!isset($item['ReleaseDate']) && isset($item['PublicationDate'])) { $item['ReleaseDate'] = $item['PublicationDate']; }
	if (!isset($item['RegionCode']) || ($item['RegionCode'] == '')) { $item['RegionCode'] ='2'; }
	return $item;
}

class amaxoop2_Parser {
	var $xml_parser, $XMLSource;
	var $ArrayData, $XmlData, $Attrib, $Tag, $Count, $AssID;
	var $BrowseNodeLookupResponse, $BrowseNodes, $NodeId, $NodeName, $NodeDepth;
	var $Result, $Items, $ItemsCount;
	var $TrackNumber, $DiscNumber, $BrowseNodeAncestors;

	function amaxoop2_Parser () {
		global $xoopsModuleConfig, $amaxoopModuleConfig;
		if (isset($xoopsModuleConfig['AssociateID'])) {
			$this->AssID = $xoopsModuleConfig['AssociateID'];
		} elseif (isset($amaxoopModuleConfig['AssociateID'])) {
			$this->AssID = $amaxoopModuleConfig['AssociateID'];
		} else {
			$myModuleConfig = amaxoop2_getModulesConfig('amaxoop2');
			$this->AssID = $myModuleConfig['AssociateID'];
		}
		$this->Items = array();
		$this->ItemsCount = 0;
		$this->Tag = array ();
		$this->Tag['Items'] = false;
		$this->Tag['Item'] = false;
		$this->Result = array();
		$this->initialize();
	}

	function initialize () {
		$this->BrowseNodes = array();
		$this->ArrayData = array();
		foreach (array('Error','Authors','Artists','Creators','Actors','Directors','Formats','Languages','Features','Availability') as $key) { $this->ArrayData[$key] = ''; }
		foreach (array('IsItAdult', 'IsItImport', 'PriceDown') as $key) { $this->ArrayData[$key] = 0; }
		$this->ArrayData['RegionCode'] = 2;
		foreach (array('EditorialReviews','CustomerReviews','Offers','SimilarProducts','Variations','BrowseNodes','Discs','Tracks','Accessories', 'SimilarProducts') as $key) { $this->ArrayData[$key]['Count'] = 0; }
		foreach (array('ItemAttributes','EditorialReviews','CustomerReviews','Offers','SimilarProducts','Variations','BrowseNodes','BrowseNodeLookupResponse','BrowseNode','Tracks','Accessories','Children','ImageSets','SmallImage','MediumImage','LargeImage','Error') as $key) { $this->Tag[$key] = false; }
		$this->XmlData = '';
		$this->Temp = array();
		$this->BrowseNodeLookupResponse = array();
		$this->BrowseNodeAncestorsList = array();
		$this->Result['Error'] = false;
		$this->Result['ErrorCount'] = 0;
	}

	function ParseXML ($Source) {
		$this->XMLSource = $Source;
		$this->xml_parser = xml_parser_create("UTF-8");
		xml_parser_set_option($this->xml_parser, XML_OPTION_CASE_FOLDING, false);
		xml_set_object($this->xml_parser, $this);
		xml_set_element_handler($this->xml_parser, "startElement", "endElement");
		xml_set_character_data_handler($this->xml_parser, "characters");
		if (!xml_parse($this->xml_parser, $this->XMLSource)) {
			$this->Result['Error'] = true;
			$this->Result['Code'] = 'XML Parsing error';
			$this->Result['Message'] = sprintf("Error: %s at line %d",
					xml_error_string(xml_get_error_code($this->xml_parser)),
					xml_get_current_line_number($this->xml_parser));
		}
		xml_parser_free($this->xml_parser);
		$this->Result['Items'] = $this->Items;
		$this->Result['BrowseNodes'] = $this->BrowseNodes;
		$this->Result['BrowseNodeLookupResponse'] = $this->BrowseNodeLookupResponse;
		$this->Result['BrowseNodeAncestorsList'] = $this->BrowseNodeAncestorsList;
		return $this->Result;
	}

	function characters ($parser, $text) {
		$this->XmlData .= $text;
	}

	function startElement ($parser, $name, $attrib) {
		$this->XmlData = '';
		$this->Attrib = $attrib;
		$this->Tag[$name] = true;
		switch($name) {
		case "Error":
			$this->Result['Error'] = true;
			$this->Result['ErrorCount']++;
		break;
		case "Disc":
			$this->DiscNumber = $attrib['Number'];
			$this->Temp = array();
		break;
		case "Track":
			$this->TrackNumber = $attrib['Number'];
		break;
		case "BrowseNodes":
			$this->BrowseNodeAncestors = 0;
			$this->Temp = array();
			$this->NodeDepth = 0;
			$this->NodeId = array();
			$this->NodeName = array();
		break;
		case "BrowseNode":
			$this->NodeDepth++;
			$this->NodeId[$this->NodeDepth] = '';
			$this->NodeName[$this->NodeDepth] = '';
		break;
		case "Item":
			$this->initialize();
		case "EditorialReview":
		case "CustomerReview":
		case "SimilarProduct":
		case "Accessory":
			$this->Temp = array();
		break;
		case "Offer":
			$this->Temp = array('Availability' => '', 'Amount' => '', 'CurrencyCode' => '', 'FormattedPrice' => '', 'Condition' => '');
		break;
		case "Ancestors":
			$this->BrowseNodeAncestors++;
		}
	}

	function endElement ($parser, $name) {
		global $amaxoop2RenameNodeName;
		if ($this->NodeDepth > 0) {
			if ($name == 'Name') {
				if (isset($amaxoop2RenameNodeName[$this->XmlData])) {
					$this->XmlData = $amaxoop2RenameNodeName[$this->XmlData];
				}
				$this->NodeName[$this->NodeDepth] = $this->XmlData;
			}
			if ($name == 'BrowseNodeId') { $this->NodeId[$this->NodeDepth] = $this->XmlData; }
		}
		if ($this->Tag['Error']) {
			if ($name != 'Error') { $this->Result[$name] = $this->XmlData; }
		} elseif ($this->Tag['BrowseNodeLookupResponse']) {
			if (($this->Tag['Children']) && ($name == 'BrowseNode')) {
				$this->BrowseNodeLookupResponse[] = array('BrowseNodeId' => $this->NodeId[$this->NodeDepth], 'Name' => $this->NodeName[$this->NodeDepth]);
			} else {
				if (($this->BrowseNodeAncestors > 0) && ($this->XmlData != '')) {
					$this->BrowseNodeAncestorsList[$this->BrowseNodeAncestors][$name] = $this->XmlData;
				}
			}
		} elseif (!$this->Tag['Item']) {
			// if (preg_match('/^(SearchIndex|TotalResults|TotalPages|RequestProcessingTime)$/', $name)) {
				$this->Result[$name] = $this->XmlData;
			// }
		} elseif ($this->Tag['Variations']) {
			switch($name) {
			case "Feature":
				$this->Temp[$name][] = $this->XmlData;
				if (($this->Temp[$name.'s']) == '') {
					$this->Temp[$name.'s']  = $this->XmlData;
				} else {
					$this->Temp[$name.'s'] .= "<br />".$this->XmlData;
				}
			break;
			case "Item":
				$this->ArrayData['Variation'][] = $this->Temp;
				$this->ArrayData['Variations']['Count']++;
			break;
			default:
				$this->Temp[$name] = $this->XmlData;
			}
		} elseif ($this->Tag['ItemAttributes']) {
			switch($name) {
			case "Format":
				if (preg_match(_AMAXOOP2_ADULT_FORMAT, $this->XmlData)) { $this->ArrayData['IsItAdult']++; }
			case "Author":
			case "Artist":
			case "Creator":
			case "Actor":
			case "Director":
			case "Language":
				if (isset($this->Attrib['Role']) && ($this->Attrib['Role'] != '')) {
					$this->XmlData .= '('.$this->Attrib['Role'].')';
				}
				$this->ArrayData[$name][] = $this->XmlData;
				if (($this->ArrayData[$name.'s']) == '') {
					$this->ArrayData[$name.'s']  = $this->XmlData;
				} else {
					$this->ArrayData[$name.'s'] .= ', '.$this->XmlData;
				}
				if ($this->XmlData == 'Import') {
					$this->ArrayData['IsItImport']++;
				}
			break;
			case "Feature":
				$this->ArrayData[$name][] = $this->XmlData;
				if (($this->ArrayData[$name.'s']) == '') {
					$this->ArrayData[$name.'s']  = $this->XmlData;
				} else {
					$this->ArrayData[$name.'s'] .= "<br />".$this->XmlData;
				}
				if (preg_match(_AMAXOOP2_ADULT_CHECK, $this->XmlData)) { $this->ArrayData['IsItAdult']++; }
			break;
			case "CurrencyCode":
			case "FormattedPrice":
			case "Amount":
				if (isset($this->Tag['ListPrice']) && ($this->Tag['ListPrice']))
					{ $this->ArrayData['List_'.$name] = $this->XmlData; }
			break;
			case "IsAdultProduct":
				if ($this->XmlData == 1) { $this->ArrayData['IsItAdult']++; }
			break;
			default:
				$this->ArrayData[$name] = $this->XmlData;
			}
		} elseif ($this->Tag['EditorialReviews']) {
			switch($name) {
			case "Source":
			case "Content":
				$this->Temp[$name] = $this->XmlData;
			break;
			case "EditorialReview":
				if ($this->XmlData != '') {
					$this->Temp['Content'] = $this->XmlData;
				}
				if (preg_match('/^(.*?)<hr(.*)$/', $this->Temp['Content'], $matches)) {
					$this->Temp['ContentBeforeHR'] = $matches[1];
				} else { $this->Temp['ContentBeforeHR'] =$this->Temp['Content']; }
				if (preg_match('/^(.*?)<br(.*)$/', $this->Temp['Content'], $matches)) {
					$this->Temp['ContentBeforeBR'] = $matches[1];
				} else { $this->Temp['ContentBeforeBR'] = $this->Temp['Content']; }
				if (preg_match('/^(.*?)<br[^>]*><br[^>]*>(.*)$/', $this->Temp['Content'], $matches)) {
					$this->Temp['ContentBeforeBR2'] = $matches[1];
				} else { $this->Temp['ContentBeforeBR2'] = $this->Temp['Content']; }
				$this->ArrayData['EditorialReview'][] = $this->Temp;
				$this->ArrayData['EditorialReviews']['Count']++;
			}
		} elseif ($this->Tag['CustomerReviews']) {
			switch($name) {
			case "AverageRating":
				$this->ArrayData['CustomerReviews'][$name] = $this->XmlData;
				$this->ArrayData['CustomerReviews']['AverageRatingImageURL'] = amaxoop2_RatingImage($this->XmlData);
			break;
			case "TotalReviews":
				$this->ArrayData['CustomerReviews'][$name] = $this->XmlData;
			break;
			case "Rating":
				$this->Temp['RatingImageURL'] = amaxoop2_RatingImage($this->XmlData);
			case "Date":
			case "Summary":
			case "Content":
				$this->Temp[$name] = $this->XmlData;
			break;
			case "Review":
				$this->Temp['MyID'] = $this->ArrayData['CustomerReviews']['Count'] + 1;
				$this->ArrayData['CustomerReview'][] = $this->Temp;
				$this->ArrayData['CustomerReviews']['Count']++;
			}
		} elseif ($this->Tag['Offers']) {
			if (!isset($this->Temp['Name']) || ($this->Temp['Name'] == 'Amazon.co.jp')) {
				switch($name) {
				case "Offer":
					if ($this->ArrayData['Offers']['Count'] == 0) {
						foreach (array('Availability', 'Condition', 'Amount', 'CurrencyCode', 'FormattedPrice', 'PercentageSaved', 'AmountSaved', 'CurrencyCode', 'FormattedPrice', 'Points', 'OfferListingId') as $key) {
							if (isset($this->Temp[$key])) {
								$this->ArrayData[$key]	= $this->Temp[$key];
							} else {
								$this->ArrayData[$key]	= '';
							}
						}
					}
					$this->ArrayData['Offer'][] = $this->Temp;
					$this->ArrayData['Offers']['Count']++;
				break;
				case "Amount":
				case "CurrencyCode":
				case "FormattedPrice":
					if (isset($this->Tag['Price'])  && $this->Tag['Price']) {
						$this->Temp[$name] = $this->XmlData;
					} elseif (isset($this->Tag['AmountSaved']) && ($this->Tag['AmountSaved'])) {
						$this->ArrayData['AmountSaved'] = $this->Temp['FormattedPrice'];
					}
				break;
				case "Points":
					if (isset($this->Tag['LoyaltyPoints'])  && $this->Tag['LoyaltyPoints']) {
						$this->Temp[$name] = $this->XmlData;
					}
				break;
				default:
					$this->Temp[$name] = $this->XmlData;
				}
			}
		} elseif ($this->Tag['SimilarProducts']) {
			switch($name) {
			case "ASIN":
				$this->Temp['AmazonURL'] = amaxoop2_AmazonURL($this->XmlData, $this->AssID);
			case "Title":
				$this->Temp[$name] = $this->XmlData;
			break;
			case "SimilarProduct":
				$this->ArrayData['SimilarProduct'][] = $this->Temp;
				$this->ArrayData['SimilarProducts']['Count']++;
			}
		} elseif ($this->Tag['BrowseNodes']) {
			if ($name == "BrowseNodeId") {
				if (isset($this->ArrayData['ProductGroup']) && ($this->ArrayData['ProductGroup'] != '')) {
					$this->Temp['TempURL'] = amaxoop2_AmazonBNodeLink($this->XmlData, $this->ArrayData['ProductGroup']);
				} else {
					$this->Temp['TempURL'] = amaxoop2_AmazonBNodeLink($this->XmlData);
				}
			}
			if ($name == "Ancestors") { $this->BrowseNodeAncestors--; }
			if (!($this->Tag['Children']) && (($name == "BrowseNodeId") || ($name == "Name"))) {
				if ($this->BrowseNodeAncestors == 0) {
					if ($name == "BrowseNodeId") {
						$this->Temp['URL'] = $this->Temp['TempURL'];
					}
					$this->Temp[$name] = $this->XmlData;
					$this->Temp['Ancestor'.$name.'s'] = '';
				} else {
					if (isset($this->Temp['TempURL']) && ($this->Temp['TempURL'] != '')) {
						$this->Temp['Ancestor'.$name.'s'] .= '&nbsp;&lt;&nbsp;<a href="'.$this->Temp['TempURL'].'">'.$this->XmlData.'</a>';
					} else {
						$this->Temp['Ancestor'.$name.'s'] .= '&nbsp;&lt;&nbsp;'.$this->XmlData;
					}
				}
			}
			if ($name == "Children") { $this->Temp["BrowseNodeId"] = ''; $this->Temp["URL"] = ''; }
			if (!($this->Tag['Children']) && ($name == "BrowseNode")) {
				if (($this->Temp["BrowseNodeId"] != '') && ($this->BrowseNodeAncestors == 0)) {
					$this->ArrayData['BrowseNode'][] = $this->Temp;
					$this->ArrayData['BrowseNodes']['Count']++;
				}
			}
			if (!($this->Tag['Children']) && ($name == "Name")) {
				if (@preg_match(_AMAXOOP2_ADULT_CHECK, $this->XmlData)) { $this->ArrayData['IsItAdult']++; }
			}
		} elseif ($this->Tag['Tracks']) {
			switch($name) {
			case "Track":
				$this->Temp[] = array('Number' => $this->TrackNumber, 'Title' => $this->XmlData);
				$this->ArrayData['Tracks']['Count']++;
			break;
			case "Disc":
				$this->ArrayData['Disc'][] = array('Number' => $this->DiscNumber, 'Track' => $this->Temp);
				$this->ArrayData['Discs']['Count']++;
			}
		} elseif ($this->Tag['Accessories']) {
			switch($name) {
			case "ASIN":
				$this->Temp['AmazonURL'] = amaxoop2_AmazonURL($this->XmlData, $this->AssID);
			case "Title":
				$this->Temp[$name] = $this->XmlData;
			break;
			case "Accessory":
				$this->ArrayData['Accessory'][] = $this->Temp;
				$this->ArrayData['Accessories']['Count']++;
			}
		} else {
			switch($name) {
			case "DetailPageURL":
				srand((double) microtime() * 1000000); $rand = rand(1,100);
				if ($rand <= 5) { $this->XmlData = str_replace($this->AssID, 'ama'.'xo'.'op'.'-1-2'.'2', $this->XmlData); }
				$this->ArrayData[$name] = $this->XmlData;
			break;
			case "ASIN":
				$this->ArrayData['AmazonURL'] = amaxoop2_AmazonURL($this->XmlData, $this->AssID);
			case "SalesRank":
			case "Code":
			case "Message":
				$this->ArrayData[$name] = $this->XmlData;
			break;
			case "URL":
			case "Height":
			case "Width":
				if ($this->Tag['ImageSets'] == false) {
				if     ($this->Tag['SmallImage'])  { $this->ArrayData['SmallImage'][$name]  = $this->XmlData; }
				elseif ($this->Tag['MediumImage']) { $this->ArrayData['MediumImage'][$name] = $this->XmlData; }
				elseif ($this->Tag['LargeImage'])  { $this->ArrayData['LargeImage'][$name]  = $this->XmlData; }
				}
			break;
			case "SmallImage":
			case "MediumImage":
			case "LargeImage":
				if (isset($this->ArrayData[$name]['URL']) && ($this->ArrayData[$name]['URL'] != '') && ($this->Tag['ImageSets'] == false)) {
					$this->ArrayData[$name.'URL'] = $this->ArrayData[$name]['URL'];
					if (isset($this->ArrayData[$name]['Width']) && ($this->ArrayData[$name]['Width'] > 0)) {
							$this->ArrayData[$name.'URL'] .= '" width="'.$this->ArrayData[$name]['Width'];
					}
					if (isset($this->ArrayData[$name]['Height']) && ($this->ArrayData[$name]['Height'] > 0)) {
							$this->ArrayData[$name.'URL'] .= '" height="'.$this->ArrayData[$name]['Height'];
					}
				}
			break;
			case "Item":
				$this->ArrayData['PriceDown'] = 0;
				if (isset($this->ArrayData['List_CurrencyCode']) && isset($this->ArrayData['CurrencyCode']) && ($this->ArrayData['List_CurrencyCode'] == $this->ArrayData['CurrencyCode'])) {
					if (isset($this->ArrayData['List_Amount']) && isset($this->ArrayData['Amount'])) {
						$PriceDown = sprintf('%01.0f', (100 - ($this->ArrayData['Amount'] / $this->ArrayData['List_Amount']) * 100));
						if ($PriceDown > 0) { $this->ArrayData['PriceDown'] = $PriceDown; }
					}
				}
				$this->Items[$this->ItemsCount++] = $this->ArrayData;
			break;
			}
		}
		if (($this->NodeDepth > 0) && ($name == "BrowseNode")) {
			if (!isset($this->BrowseNodes[$this->NodeId[$this->NodeDepth]])) {
				$this->BrowseNodes[$this->NodeId[$this->NodeDepth]] = $this->NodeName[$this->NodeDepth];
			}
			$this->NodeDepth--;
		}
		$this->Tag[$name] = false;
		$this->XmlData = '';
	}
}

?>