<?php
//  ------------------------------------------------------------------------ //
//              Amaxoop2 - Amazon Associate Module for XOOPS                 //
//                     Copyright (c) 2005 taquino                            //
//                     <http://xoops.taquino.net/>                           //
//                  This software is a 'traffic-ware'                        //
//  ------------------------------------------------------------------------ //

require_once './header.php';

$xoopsOption['template_main'] = "amax2_topseller.html";

$old_meta_robots = $xoopsTpl->get_template_vars("xoops_meta_robots");
$new_meta_robots = str_replace(',follow',',nofollow', $old_meta_robots);
$xoopsTpl->assign("xoops_meta_robots", $new_meta_robots );

//	Get Query
$BNode = ''; $SIndex = '';
foreach ($_GET as $key => $val) {
	if (preg_match('/(b|n)/i', $key) && preg_match('/^[\d]+$/', $val)) { $BNode = $val; }
	if (preg_match('/(s|i)/i', $key) && isset($amaxoop2SearchIndexes[$val])) { $SIndex = $val; }
}
if (!preg_match('/^[\d]+$/', $BNode)) { $BNode = ''; }
if (!isset($amaxoop2SearchIndexes[$SIndex])) { $SIndex = ''; $BNode = ''; }
if ($SIndex == '') {  $BNode = ''; $SName = ''; } else { $SName = $amaxoop2SearchIndexes[$SIndex]; }
if (($SIndex != '') && ($BNode == '')) {
	$BNode = $amaxoop2TopNode[$SIndex];
	$BName = $amaxoop2SearchIndexes[$SIndex];
}

//	Get Node Info
if (($BNode != '') && ($SIndex != '')) {
	$Queries = array('Operation' => 'ItemSearch,BrowseNodeLookup', 'ItemSearch.1.ResponseGroup' => 'Large',
			 'ItemSearch.1.BrowseNode' => $BNode, 'ItemSearch.1.ItemPage' => 1,
			 'BrowseNodeLookup.2.ResponseGroup' => 'BrowseNodeInfo',
			 'BrowseNodeLookup.2.BrowseNodeId' => $BNode,
			 'SearchIndex' => $SIndex, 'Sort' => 'salesrank');
	$AMStr = amaxoop2_fetch_aws($Queries);
	$MyParser = new amaxoop2_Parser();
	$AMResult = amaxoop2_array_mb_convert_encoding($MyParser->ParseXML($AMStr));
	$NodesCount = 0;
	foreach ($AMResult['BrowseNodeLookupResponse'] as $BrowseNode) {
		$Nodes[] = array('ID' => $BrowseNode['BrowseNodeId'], 'SIndex' => $SIndex,
			 'Name' => htmlspecialchars($BrowseNode['Name']));
		$NodesCount++;
	}
	$xoopsTpl->assign('NodesCount', $NodesCount);
	if ($NodesCount > 0) { $xoopsTpl->assign('Nodes', $Nodes); }
	foreach ($AMResult['BrowseNodes'] as $key => $val) {
		if ($key == $BNode) {
			$BName = htmlspecialchars($val);
		}
	}
	if (isset($AMResult['Items'])) {
		$items = array();
		$cnt = 0;
		amaxoop2_UpdateItemsDB($AMResult['Items']);
		foreach ($AMResult['Items'] as $AM) {
			$item = array();
			$AM = amaxoop2_CustomizeData($AM);
			foreach ($AM as $key => $val) {
				if ($key == 'Creators') {
					$item[$key] = htmlspecialchars(preg_replace('/\([^\)]*\)/', '', $val));
				} elseif (preg_match('/^(ASIN|ThumbnailURL|DetailPageURL|AmazonURL|MediumImageURL)$/', $key)) {
					$item[$key] = $val;
				} elseif (($key == 'EditorialReview') && isset($val[0]['Content'])) {
					$item[$key]['Excerpt'] = amaxoop2_AutoExcerpt(trim($val[0]['Content']), 100);
				} elseif ($key == 'CustomerReviews') {
					if (isset($val['AverageRating'])) {
						$item['AverageRating'] = $val['AverageRating'];
						$item['AverageRatingImageURL'] = $val['AverageRatingImageURL'];
					}
				} elseif ($key == 'ProductIcon') {
					$item['ProductIcon'] = preg_replace('/24/', '18', $val);
				} elseif (!is_array($val)) {
					$item[$key] = htmlspecialchars($val);
				}
			}
			$item['AlreadyEntered'] = (isset($ASINlist[$item['ASIN']]) ? $ASINlist[$item['ASIN']] : 0);
			if (isset($item['ReleaseDate'])) { $item['Release'] = $item['ReleaseDate'].' '._AMAXOOP2_RELEASE; }
			if (!isset($item['ThumbnailURL']) || ($item['ThumbnailURL'] == '')) {
				$item['ThumbnailURL'] = 'http://images-jp.amazon.com/images/P/'.$item['ASIN'].'.09._AA'._AMAX2_DefaultThumbSize.'_SCMZZZZZZZ_.jpg" width="'._AMAX2_DefaultThumbSize.'" height="'._AMAX2_DefaultThumbSize.'';
			}
//			if (isset($item['FormattedPrice']) && ($item['FormattedPrice'] != '')) {
				$items[] = $item;
				$cnt++;
//			}
		}
		$xoopsTpl->assign('itemsCount', $cnt);
		$xoopsTpl->assign('items', $items);
		$xoopsTpl->assign('NodeAncestor', $AMResult['BrowseNodes']);
		$NodeParentsList = $BName;
		foreach ($AMResult['BrowseNodeAncestorsList'] as $Temp) {
			if (!in_array($Temp['BrowseNodeId'] ,$amaxoop2TopNode)) {
				if ($NodeParentsList != '') { $NodeParentsList .= '&nbsp;&lt;&nbsp;'; }
				$NodeParentsList .= '<a href="'.XOOPS_URL.'/modules/amaxoop2/topseller.php?b='.$Temp['BrowseNodeId'].'&amp;s='.$SIndex.'">'.$Temp['Name'].'</a>';
			}
		}
		if ($NodeParentsList != '') {
			$NodeParentsList .= '&nbsp;&lt;&nbsp;<a href="./topseller.php?s='.$SIndex.'">'.$SName.'</a>';
		}
	}
} else {
	$Nodes = array();
	$NodesCount = 0;
	foreach ($amaxoop2TopNode AS $key => $val) {
		$Nodes[] = array('ID' => $val, 'Name' => $amaxoop2SearchIndexes[$key], 'SIndex' => $key);
		$NodesCount++;
	}
	$xoopsTpl->assign('Nodes', $Nodes);
	$xoopsTpl->assign('NodesCount', $NodesCount);
	$xoopsTpl->assign('itemsCount', 0);
}
$Title = 'Amazon Topseller';
$xoopsTpl->assign('BNode', $BNode);
$xoopsTpl->assign('SIndex', $SIndex);
if ($BName != '') { $Title .= " - $BName"; }
//if ($SIndex != '') { $Title .= " (<a href=\"./topseller.php?s=$SIndex\">$SName</a>)"; }
$xoopsTpl->assign('Title', $Title);
$xoopsTpl->assign('NodeParentsList', $NodeParentsList);
$xoopsTpl->assign('AmazonNodeLink', amaxoop2_AmazonBNodeLink($BNode));
$xoopsTpl->assign('xoopsModuleConfig', $xoopsModuleConfig);

$org_pagetitle = $xoopsTpl->get_template_vars("xoops_pagetitle");
$new_pagetitle = $SIndex.' '.$BName;
$xoopsTpl->assign("xoops_org_pagetitle", $org_pagetitle );
$xoopsTpl->assign("xoops_pagetitle", $new_pagetitle );

include XOOPS_ROOT_PATH.'/footer.php';
?>