<?php
//  ------------------------------------------------------------------------ //
//              Amaxoop2 - Amazon Associate Module for XOOPS                 //
//                     Copyright (c) 2005 taquino                            //
//                     <http://xoops.taquino.net/>                           //
//                  This software is a 'traffic-ware'                        //
//  ------------------------------------------------------------------------ //
/*
 * Smarty plugin
 *
 * Type:	function
 * Name:	amaxoop
 * Purpose:	convert ASIN to Image/Title with link
 * Author:	http://xoops.taquino.net/
 * Examples:
 * {amaxoop ASIN=$ASIN}
 * {amaxoop ASIN=$ASIN image=(thumbnail|small|medium|large|[\d]+)}
 */

//	̃vOC̎gp@
//	 ̃t@CAȂ̃T[ỏL̃fBNgɓĂ
//	 XOOPS_ROOT_PATH/class/smarty/plugins/
//	 ́Asmarty^OŏL̒ʂA<{amaxoop ASIN=xxxxxxxx}>ƂΎg܂

function smarty_function_amaxoop ($params, &$smarty) {
	require_once XOOPS_ROOT_PATH.'/modules/amaxoop2/include/library.php';
	require_once XOOPS_ROOT_PATH.'/modules/amaxoop2/include/parameters.php';
	if (!amaxoop2_ModuleAvailabirity('amaxoop2')) {
		$smarty->trigger_error("amaxoop: amaxoop2 module not activated");
		return;
	}
	$amaxoopModuleConfig = amaxoop2_getModulesConfig('amaxoop2');
	$ASIN = '';
	$IMG = '';
	foreach ($params as $key => $val) {
		if (preg_match('/ASIN/i', $key)) { $ASIN = trim($val); }
		if (preg_match('/image/i', $key)) { $IMG = strtoupper(trim($val)); }
	}
	if (!preg_match('/^[A-Z0-9]{10}$/', $ASIN)) {
		$smarty->trigger_error("amaxoop: missing or invalid 'ASIN' parameter");
		return;
	}
	$AMResult = amaxoop2_SearchASIN($ASIN);
	$MyParser = new amaxoop2_Parser();
	$Result = amaxoop2_array_mb_convert_encoding($MyParser->ParseXML($AMResult));
	if (isset($Result['Error']) && $Result['Error']) {
		$smarty->trigger_error("amaxoop: error on accessing amazon web service");
		return;
	}
	$item = $Result['Items'][0];
	unset ($AMResult, $Result);
	amaxoop2_UpdateItemDB($item);
	$item = amaxoop2_CustomizeData($item);
	if	($IMG == 'SMALL') { $IMG = 'SmallImageURL'; }
	elseif	($IMG == 'MEDIUM') { $IMG = 'MediumImageURL'; }
	elseif	($IMG == 'LARGE') { $IMG = 'LargeImageURL'; }
	elseif	(preg_match('/^[\d]+$/', $IMG)) {
		$item['MyThumbnailURL'] = amaxoop2_ThumbnailURL($item['MediumImageURL'], $IMG);
		$IMG = 'MyThumbnailURL';
	} else { $IMG = 'ThumbnailURL'; }
	if ($amaxoopModuleConfig['UseAmaxo'] == 0) {
		$href = amaxoop2_AmazonURL($ASIN, $amaxoopModuleConfig['AssociateID']);
		$target = 'amaxoop';
	} else {
		$href = XOOPS_URL."/modules/amaxoop2/amaxo.php?ASIN=$ASIN";
		$target = '_top';
	}
	if ($IMG == '') {
		$ret =	'<a href="'.$href.'" title="Amazon.co.jp - '.htmlspecialchars($item['FormattedPrice'].
			' - '.$item['Availability']).'" target="'.$target.'">'.htmlspecialchars($item['Title']).'</a>';
	} else {
		$ret =	'<a href="'.$href.'" title="'.htmlspecialchars($item['Title']).'" target="'.$target.'">'.
			'<img src="'.$item[$IMG].'" alt="'.htmlspecialchars($item['Title']).'" /></a>';
	}
	return $ret;
}
?>
