<?php
//  ------------------------------------------------------------------------ //
//              Amaxoop2 - Amazon Associate Module for XOOPS                 //
//                     Copyright (c) 2005 taquino                            //
//                     <http://xoops.taquino.net/>                           //
//                  This software is a 'traffic-ware'                        //
//  ------------------------------------------------------------------------ //

require_once '../../../mainfile.php';
$templatefile = XOOPS_ROOT_PATH.'/modules/amaxoop2/utility/detail.html';

require_once XOOPS_ROOT_PATH.'/modules/amaxoop2/include/parameters.php';
require_once XOOPS_ROOT_PATH.'/modules/amaxoop2/include/library.php';
include_once XOOPS_ROOT_PATH.'/modules/amaxoop2/language/japanese/main.php';

$myts =& MyTextSanitizer::getInstance();

define ("_Amax2CatDB_",		$xoopsDB->prefix('amaxoop2_categories'));
define ("_Amax2Cat2DB_",	$xoopsDB->prefix('amaxoop2_subcategories'));
define ("_Amax2ItemDB_",	$xoopsDB->prefix('amaxoop2_items'));
define ("_Amax2VoteDB_",	$xoopsDB->prefix('amaxoop2_votedata'));

$amaxoopModuleConfig = amaxoop2_getModulesConfig('amaxoop2');
$AssID = $amaxoopModuleConfig['AssociateID'];
$SubID = $amaxoopModuleConfig['SubscriptionID'];

include_once XOOPS_ROOT_PATH.'/class/template.php';

header ('Content-Type:text/html; charset='._CHARSET);
$tpl = new XoopsTpl();
$tpl->xoops_setCaching(2);
$tpl->xoops_setCacheTime(0);

$xoops = array(	'langcode' => _LANGCODE, 'charset' => _CHARSET, 'url' => XOOPS_URL,
		'sitename' => htmlspecialchars($xoopsConfig['sitename'], ENT_QUOTES),
		'meta_robots' => 'noindex,nofollow', 'meta_generator' => 'amaxoop2',
		'themecss' => xoops_getcss($xoopsConfig['theme_set']));
$tpl->assign('xoops_param', $xoops);

$ASIN = (isset($_GET['ASIN']) ? $_GET['ASIN'] : '');
$ASIN = (preg_match('/^[a-zA-Z0-9]+$/', $ASIN) ? $ASIN : '');
$lid  = (isset($_GET['lid']) ? intval($_GET['lid']) : 0);
$cid  = (isset($_GET['cid']) ? intval($_GET['cid']) : 0);

if (($ASIN == '') && ($lid != 0)) {
	$sql = "SELECT cid, ASIN FROM "._Amax2ItemDB_." WHERE lid = $lid";
	list($cid, $ASIN) = $xoopsDB->fetchRow($xoopsDB->query($sql));
}
if ($cid != 0) {
	$sql = "SELECT AssID FROM "._Amax2CatDB_." WHERE cid = $cid";
	list($AssID) = $xoopsDB->fetchRow($xoopsDB->query($sql));
	if ($ASIN == '') {
		$sql = "SELECT ASIN FROM "._Amax2ItemDB_." ORDER BY EntryTime";
		list($ASIN) = $xoopsDB->fetchRow($xoopsDB->query($sql, 1));
	}
}
if ($ASIN == '') {
	$sql = "SELECT ASIN FROM "._Amax2ItemDB_." ORDER BY RAND()";
	list($ASIN) = $xoopsDB->fetchRow($xoopsDB->query($sql, 1));
}
if ($ASIN == '') {
	if (!isset($_SERVER['HTTP_REFERER']) ||($_SERVER['HTTP_REFERER'] == '') || ($_SERVER['HTTP_REFERER'] == XOOPS_URL.'/modules/amaxoop2/')) {
		redirect_header(XOOPS_URL, 0,'No ASIN Parameter'); exit();
	} else {
		redirect_header(XOOPS_URL.'/modules/amaxoop2/', 0,'No ASIN Parameter'); exit();
	}
}
if ($_SERVER['REMOTE_ADDR'] != $xoopsConfig['my_ip']) {
	$xoopsDB->queryF("UPDATE "._Amax2ItemDB_." SET Clicks = Clicks + 1 WHERE ASIN = '$ASIN'");
}
$AMResult = amaxoop2_SearchASIN($ASIN);
$MyParser = new amaxoop2_Parser();
$Result = amaxoop2_array_mb_convert_encoding($MyParser->ParseXML($AMResult));
if (isset($Result['Error']) && $Result['Error']) {
	redirect_header(XOOPS_URL.'/modules/amaxoop2/', 5, _AMAXOOP2_ERR_GETDATA.$Result['Code'].'<br /> ('.$Result['Message'].')');
}
$tpl->assign('item', $Result['Items'][0]);

$Amaxoop2 = array('Count' => 0);
$sql = "SELECT Description, Excerpt, EntryTime, uname FROM "._Amax2ItemDB_." WHERE ASIN = '$ASIN' ORDER BY EntryTime DESC";
$res = $xoopsDB->query($sql);
while (list($Description, $Excerpt, $EntryTime, $uname) = $xoopsDB->fetchRow($res)) {
	if (trim($Description) != "") {
		$Amaxoop2['Comment'][] = array('Description'	=> $myts->displayTarea($Description,0,1,1,1,1),
						'Excerpt'	=> $myts->htmlSpecialChars($Excerpt),
						'uname'		=> $myts->htmlSpecialChars($uname),
						'EntryDT'	=> strftime('%Y/%m/%d', $EntryTime));
		$Amaxoop2['Count']++;
	}
}
$tpl->assign('Amaxoop2', $Amaxoop2);

$tpl->display($templatefile);
?>