<?php

	// a plugin for amaxoop2

	if( ! defined( 'XOOPS_ROOT_PATH' ) ) exit ;

	$module_handler =& xoops_gethandler('module');
	$module =& $module_handler->getByDirname('amaxoop2');
	$config_handler =& xoops_gethandler('config');
	$Amaxoop2ModConfig = $config_handler->getConfigsByCat(0, $module->getVar('mid'));

	/*
		$db : db instance
		$myts : MyTextSanitizer instance
		$this->year : year
		$this->month : month
		$this->date : date
		$this->week_start : sunday:0 monday:1
		$this->user_TZ : user's timezone (+1.5 etc)
		$this->server_TZ : server's timezone (-2.5 etc)
		$tzoffset_s2u : the offset from server to user
		$now : the result of time()
		$plugin = array('dirname'=>'dirname','name'=>'name','dotgif'=>'*.gif')
	        $just1gif : 0 or 1

		$plugin_returns[ DATE ][]
	*/

	// set range (added 86400 second margin "begin" & "end")
	$range_start_s = mktime(0,0,0,$this->month,0,$this->year) ;
	$range_end_s = mktime(0,0,0,$this->month+1,1,$this->year) ;

	// query (added 86400 second margin "begin" & "end")
	$result = $db->query( "SELECT Title,lid,EntryTime,cid,Excerpt FROM ".$db->prefix("amaxoop2_items")." WHERE EntryTime >= $range_start_s AND EntryTime < $range_end_s AND Status = 1" ) ;

	while( list( $title , $lid , $server_time , $cid , $excerpt ) = $db->fetchRow( $result ) ) {
		$user_time = $server_time + $tzoffset_s2u ;
		if( date( 'n' , $user_time ) != $this->month ) continue ;
		$target_date = date('j',$user_time) ;
		if (preg_match('/^([^\[\(\<]+)([\[\(\<])/', $title, $m)) { $title = $m[1]; }
		if ($Amaxoop2ModConfig['BlogOrLink']) {
			$mylink = XOOPS_URL."/modules/{$plugin['dirname']}/article.php?lid=$lid&amp;caldate={$this->year}-{$this->month}";
		} else {
			$mylink = XOOPS_URL."/modules/{$plugin['dirname']}/index.php?lid=${lid}#amaxoop2_item_${lid}";
		}
		$tmp_array = array(
			'dotgif' => $plugin['dotgif'] ,
			'dirname' => $plugin['dirname'] ,
			'link' => $mylink ,
			'id' => $lid ,
			'server_time' => $server_time ,
			'user_time' => $user_time ,
			'name' => 'lid' ,
			'title' => $myts->htmlSpecialChars( $title ) ,
			'description' => $myts->htmlSpecialChars( $excerpt )
		) ;
	        if( $just1gif ) {
	            // just 1 gif per a plugin & per a day
	            $plugin_returns[ $target_date ][ $plugin['dirname'] ] = $tmp_array ;
	        } else {
	            // multiple gifs allowed per a plugin & per a day
	            $plugin_returns[ $target_date ][] = $tmp_array ;
	        }
	}


?>