<?php
//  ------------------------------------------------------------------------ //
//           amaxoop.inc.php - Plugin for XOOPS PukiWiki Module              //
//                     Copyright (c) 2005 taquino.                           //
//                     <http://xoops.taquino.net/>                           //
//  ------------------------------------------------------------------------ //

require_once XOOPS_ROOT_PATH.'/modules/amaxoop2/include/parameters.php';
require_once XOOPS_ROOT_PATH.'/modules/amaxoop2/include/library.php';

global $xoopsConfig;
if ($xoopsConfig['language'] == 'japanese') {
	define('_amaxoop_pwpin_similar', 'Ϣʤ򸫤');
	define('_amaxoop_pwpin_search',  'Amazonʤ򸡺');
} else {
	define('_amaxoop_pwpin_similar', 'Similar Products');
	define('_amaxoop_pwpin_search',  'Search Aamzon Products');
}

//	Plugin version - used to define cache filename.
define('_amaxoop_pwpin_version', '2000');

//	If you don't want to use cache, please comment out this line.
//define('_amaxoop_pwpin_UseCache', 1);

//	Image display option. (Operation = 'image')
//define('_amaxoop_pwpin_image_size',  'Small');
define('_amaxoop_pwpin_image_size',  'Medium');
define('_amaxoop_pwpin_image_style', ' style="float:left;margin:0 12px 12px 0;border-style:none;"');

//	If you use not EUC-JP encoding, configure this function.
function plugin_amaxoop_myts($str) {
	//	$str = mb_convert_encoding($str, 'UTF-8', 'EUC-JP');
	return $str;
}

//	To make compatibility for b-wiki.
if (!defined('P_CACHE_DIR')) { define('P_CACHE_DIR', CACHE_DIR); }

//	Expire old cache files
plugin_amaxoop_cache_expire();

//  ------------------------------------------------------------------------ //

function plugin_amaxoop_init() {
	global $xoopsModuleConfig;
	$messages['_amaxoop_messages'] = array();
	$module_handler	=& xoops_gethandler('module');
	$amax2_module =& $module_handler->getByDirname('amaxoop2');
	$amax1_module =& $module_handler->getByDirname('amaxoop');
	if	(is_object($amax2_module)) { $messages['_amaxoop_messages'] = amaxoop2_getModulesConfig('amaxoop2'); }
	elseif  (is_object($amax1_module)) { $messages['_amaxoop_messages'] = amaxoop2_getModulesConfig('amaxoop'); }
	else	{
			$messages['_amaxoop_messages']['AssociateID'] = 'amaxoop-1-22';
			$messages['_amaxoop_messages']['SubscriptionID'] = '0EKVYRPBK0HDA1DP3EG2';
	}
	$messages['_amaxoop_messages']['default_search'] = 'Blended';
	$messages['_amaxoop_messages']['UpdateInterval'] = 1 * 60 * 60;
	$xoopsModuleConfig['AssociateID'] = $messages['_amaxoop_messages']['AssociateID'];
	$xoopsModuleConfig['SubscriptionID'] = $messages['_amaxoop_messages']['SubscriptionID'];
	set_plugin_messages($messages);
}

function plugin_amaxoop_convert($args) {
	global $_amaxoop_messages, $script, $vars;
	$args = func_get_args();

	$Operation	= trim(isset($args[0]) ? $args[0] : '');
	$Parameter	= trim(isset($args[1]) ? $args[1] : '');
	$SearchIndex	= trim(isset($args[2]) ? $args[2] : '');
	$SearchIndex	= (($SearchIndex != '') ? $SearchIndex : $_amaxoop_messages['default_search']);
	$Limit		= (isset($args[3]) ? intval($args[3]) : 0);
	$Limit		= (($Limit != 0) ? $Limit : 5);
	$ret = '';

	if (defined('_amaxoop_pwpin_UseCache')) {
		$CacheFilePath	= P_CACHE_DIR.'block_'.md5(implode('', $args).$vars['page']).'_'._amaxoop_pwpin_version.'.amx';
		if (file_exists($CacheFilePath) && ($fp = fopen($CacheFilePath, 'r'))) {
			while (!feof($fp)) { $ret .= fgets($fp, 1024); }
			fclose($fp);
			return $ret;
		}
	}

	$AssID = $_amaxoop_messages['AssociateID'];
	$SubID = $_amaxoop_messages['SubscriptionID'];

	if		(preg_match('/^key/i', $Operation)) {
		if ($Parameter == '') {
			if(preg_match('/\[\[(.+)\]\]/',$vars['page'],$matches)) { $Parameter = $matches[1]; }
			else { $Parameter = $vars['page']; }
		}
		$AMResult = amaxoop2_SearchKeyWord	($Parameter, $SearchIndex, 1);
	} elseif	(preg_match('/^(asi|ima)/i', $Operation)) {
		$AMResult = amaxoop2_SearchASIN		($Parameter);
	} elseif	(preg_match('/^(jan|ean)/i', $Operation)) {
		$AMResult = amaxoop2_SearchEAN		($Parameter, $SearchIndex);
	} elseif	(preg_match('/^upc/i', $Operation)) {
		$AMResult = amaxoop2_SearchUPC		($Parameter, $SearchIndex);
	} elseif	(preg_match('/^sim/i', $Operation)) {
		$AMResult = amaxoop2_SearchSimilar	($Parameter);
	} elseif	(preg_match('/^bro/i', $Operation)) {
		$AMResult = amaxoop2_SearchNode		($Parameter, $SearchIndex, 1);
	} else {
		return '<form action="'.$script.'" method="post">'.
		       '<input type="hidden" name="refer" value="'.$vars['page'].'" />'.
		       '<input type="hidden" name="plugin" value="amaxoop" />'.
		       '<input type="hidden" name="searchindex" value="'.$SearchIndex.'" />'.
		       '<input type="text" name="keyword" value="'.$Parameter.'" size="16" />&nbsp;'.
		       '<input type="submit" name="go" value="'._amaxoop_pwpin_search.'" />'.
		       '</form>';
	}
	$MyParser = new amaxoop2_Parser();
	$Result = amaxoop2_array_mb_convert_encoding($MyParser->ParseXML($AMResult));
	if ($Result['Err']) { return $AMResult['ErrDescription'].' : '.$Operation.' - '.$Parameter; }

	$items = $Result['Items'];
	amaxoop2_UpdateItemsDB($items);
	$i = 0;
	foreach ($items as $item) {
		if ($item['ASIN'] != '') {
			if (isset($item['DetailPageURL'])) { $URL = $item['DetailPageURL']; }
				else { $URL = amaxoop2_AmazonURL($item['ASIN'], $AssID); }
			if (preg_match('/^ima/i', $Operation)) {
				$ret = '<a href="'. $script.'?plugin=amaxoop&amp;refer='.$vars['page'].'&amp;asin='.$item['ASIN'].'">'.
				       '<img src="'.$item[_amaxoop_pwpin_image_size.'ImageURL'].'"'.
				       ' alt="'.htmlspecialchars($item['Title']).'" '._amaxoop_pwpin_image_style.'></a>';
				break;
			}
			if (!isset($item['SmallImage'])) {
				$ret.= '<tr><td width="70" valign="middle"><a href="'.$URL.'" target="amaxoop">'.
				       '<img src="'.XOOPS_URL.'/modules/amaxoop2/images/no_image.gif" width="60" height="60" border="0" alt="Link to Amazon" /></a></td>';
			} else {
				$ret.= '<tr><td width="70" valign="middle">'.
				       '<a href="'.$URL.'" target="amaxoop"><img src="'.$item['SmallImageURL'].'" border="0" alt="Link to Amazon" /></td>';
			}
			$ret .= '<td><a href="'.$URL.'" target="amaxoop">'.htmlspecialchars($item['Title']).'</a> ('.
			        htmlspecialchars($item['FormattedPrice']).')<br />'.
			        htmlspecialchars($item['Authors']).'</td></tr>';
			if (preg_match('/^(a|u|e|j)/i', $Operation) && (isset($item['EditorialReview']))) {
				$ret.= '<tr><td colspan="2">'.$item['EditorialReview'][0]['ContentBeforeBR'].'</td></tr>';
			}
			if (++$i >= $Limit) { break; }
		}
	}
	if (!preg_match('/^ima/i', $Operation)) { $ret = '<table>'.$ret.'</table>'; }
	$ret = plugin_amaxoop_myts($ret);

	if (defined('_amaxoop_pwpin_UseCache')) {
		if ($fp = fopen($CacheFilePath, 'w')) {
			fputs($fp, $ret);
			fclose($fp);
		}
	}

	return $ret;
}


function plugin_amaxoop_action() {
	global $xoopsModuleConfig, $_amaxoop_messages, $vars;
	$body = '';

	if (defined('_amaxoop_pwpin_UseCache')) {
		$CacheFilePath	= P_CACHE_DIR.'action_'.md5(implode('', $vars)).'_'._amaxoop_pwpin_version.'.amx';
		if (file_exists($CacheFilePath) && ($fp = fopen($CacheFilePath, 'r'))) {
			while (!feof($fp)) { $body .= fgets($fp, 1024); }
			fclose($fp);
			return array('msg' => 'Amaxoop Search Result', 'body' => $body);
		}
	}

	$AssID = $_amaxoop_messages['AssociateID'];
	$SubID = $_amaxoop_messages['SubscriptionID'];

	if (isset($vars['asin']) && ($vars['asin'] != '')) {
		$AMResult = amaxoop2_SearchASIN		($vars['asin']);
	} elseif (isset($vars['keyword']) && ($vars['keyword'] != '')) {
		$AMResult = amaxoop2_SearchKeyWord2	($vars['keyword'], $vars['searchindex'], 1);
	} elseif (isset($vars['browsenode']) && ($vars['browsenode'] != '')) {
		$AMResult = amaxoop2_SearchNode		($vars['browsenode'], $vars['searchindex'], 1);
	} elseif (isset($vars['similar']) && ($vars['similar'] != '')) {
		$AMResult = amaxoop2_SearchSimilar	($vars['similar']);
	} else {
		return array('msg' => 'Amaxoop Error', 'body' => 'Missing or Invalid Parameter(s)');
	}

	$MyParser = new amaxoop2_Parser();
	$AMResult = amaxoop2_array_mb_convert_encoding($MyParser->ParseXML($AMResult));
	if (isset($AMResult['Err'])) { return $AMResult['ErrDescription'].' : '.$Operation.' - '.$Parameter; }

	$items = $AMResult['Items'];
	amaxoop2_UpdateItemsDB($items);
	$i = 0;

	foreach ($items as $item) {
		if (isset($item['DetailPageURL'])) { $URL = $item['DetailPageURL']; }
			else { $URL = amaxoop2_AmazonURL($item['ASIN'], $AssID); }
		if ($body != '') { $body .= '<hr />'; }
		if (isset($item['MediumImage'])) {
			$body.= '<a href="'.$URL.'" target="amaxoop"><img src="'.$item['MediumImageURL'].'" border="0" style="float:left; margin:12px;" alt="Link to Amazon" /></a>';
		} else {
			$body.= '<a href="'.$URL.'" target="amaxoop"><img src="'.XOOPS_URL.'/modules/amaxoop/images/no_image.gif" border="0" style="float:left; margin:12px;" alt="Link to Amazon" /></a>';
		}
		$body .= '<br /><a href="'.$URL.'" target="amaxoop">'.htmlspecialchars($item['Title']).'</a><br />'.
		        htmlspecialchars($item['Authors']).'<br />';
		if ($item['RatingImageURL'] != '') {
			$body .= '<img src="'.$item['RatingImageURL'].'" alt="'.$item['AverageRating'].'"><br />';
		}
		$body .= htmlspecialchars($item['FormattedPrice']).' ('.htmlspecialchars($item['Availability']).')'.'<br />';
		if (trim($item['EditorialReview']) != '') {
			$body .= '<hr />'.$item['EditorialReview'][0]['Content'];
		}
		$body .= '<br clear="all">';
	}

	$body = plugin_amaxoop_myts($body);
	if (defined('_amaxoop_pwpin_UseCache')) {
		if ($fp = fopen($CacheFilePath, 'w')) {
			fputs($fp, $body);
			fclose($fp);
		}
	}
	return array('msg' => 'Amaxoop Search Result', 'body' => $body);
}

function plugin_amaxoop_inline() {
	global $_amaxoop_messages, $script, $vars;
	$args = func_get_args();

	$ID	= trim($args[0]);
	$TYPE	= trim((isset($args[1]) ? trim($args[1]) : ''));
	$TYPE	= (($TYPE == '') ? 'ASIN' : $TYPE);
	$ret = '';

	if (defined('_amaxoop_pwpin_UseCache')) {
		$CacheFilePath	= P_CACHE_DIR.'inline_'.md5(implode('', $args)).'_'._amaxoop_pwpin_version.'.amx';
		if (file_exists($CacheFilePath) && ($fp = fopen($CacheFilePath, 'r'))) {
			while (!feof($fp)) { $ret .= fgets($fp, 1024); }
			fclose($fp);
			return $ret;
		}
	}

	if ($TYPE == 'ASIN') {
		$item = amaxoop2_GetItemData($ID);
	} else {
		$AMResult = amaxoop2_SearchEAN($ID, $TYPE);;
		$MyParser = new amaxoop2_Parser();
		$Result = amaxoop2_array_mb_convert_encoding($MyParser->ParseXML($AMResult));
		$item = $Result['Items'][0];
		amaxoop2_UpdateItemDB($item);
	}
	if (isset($item['Authors']) && ($item['Authors'] != '')) {
		$ret = '<a href="'. $script.'?plugin=amaxoop&amp;refer='.$vars['page'].'&amp;asin='.$item['ASIN'].'">'.
		       htmlspecialchars($item['Title']).' ('.htmlspecialchars($item['Authors']).')</a>';
	} else {
		$ret = '<a href="'. $script.'?plugin=amaxoop&amp;refer='.$vars['page'].'&amp;asin='.$item['ASIN'].'">'.
		       htmlspecialchars($item['Title']).'</a>';
	}

	$ret = plugin_amaxoop_myts($ret);
	if (defined('_amaxoop_pwpin_UseCache')) {
		if ($fp = fopen($CacheFilePath, 'w')) {
			fputs($fp, $ret);
			fclose($fp);
		}
	}
	return $ret;
}

function plugin_amaxoop_cache_expire() {
	global $_amaxoop_messages;
	if (!defined('_amaxoop_pwpin_UseCache')) { return; }
	$DilHdl = dir(P_CACHE_DIR);
	while (($FileName = $DilHdl->read()) !== FALSE) {
		if (!preg_match('/\.amx$/', $FileName)) { continue; }
		$FilePath = P_CACHE_DIR.$FileName;
		if (!preg_match('/_'._amaxoop_pwpin_version.'\.amx$/', $FileName)) { unlink($FilePath); continue; }
		$PastTime = time() - filemtime($FliePath);
		if ($PastTime > $_amaxoop_messages['UpdateInterval']) { unlink($FliePath); }
	}
	$DilHdl->close();
}
?>